#include <wdm.h>

struct DEV_EXT
{
	int test ;
};

void Unload (	IN PDRIVER_OBJECT pDrvObj) ;

NTSTATUS DriverEntry(IN PDRIVER_OBJECT pDrvObj,IN PUNICODE_STRING pRegPath)
{
    UNICODE_STRING DevName ;
	PDEVICE_OBJECT pDevObj;
	NTSTATUS status ;

	pDrvObj->DriverUnload = Unload;
	RtlInitUnicodeString(&DevName,L"\\Device\\MyDevice0");
	
	
	// Now create the device
	status = IoCreateDevice( pDrvObj,
						sizeof (struct DEV_EXT),
						&DevName,
						FILE_DEVICE_UNKNOWN,
						0, TRUE,
						&pDevObj );

	if (!NT_SUCCESS(status))
		return status;
		
	DbgPrint("\ndevobj: address of driver object = %x",pDrvObj);
	DbgPrint("\ndevobj: address of driver object = %x",pDevObj->DriverObject);
	DbgPrint("\ndevobj: address of device ext = %x",pDevObj->DeviceExtension);
	
	
	return STATUS_SUCCESS;
}

void Unload (IN PDRIVER_OBJECT pDrvObj) 
{
	IoDeleteDevice( pDrvObj->DeviceObject );
}

