// Testor.cpp : Defines the entry point for the console application.
//

# include "stdafx.h"
# include <windows.h>

void main( )
{
	HANDLE h ;
	h = CreateFile( "\\\\.\\LOOP1",
					GENERIC_READ | GENERIC_WRITE,
					0,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,
					NULL ) ;
	
	if ( h == INVALID_HANDLE_VALUE ) 
	{
		printf( "cannot open device" ) ;
		return ;
	}

	char out [ 16 ] ;
	for ( DWORD i = 0 ; i < sizeof ( out ) ; i++ )
		out [ i ] = ( char ) i ;

	DWORD bW ;
	BOOL status = WriteFile ( h, out, sizeof ( out ), &bW, NULL ) ;
	if ( ! status ) 
	{
		printf("WriteFile failed");
		CloseHandle ( h ) ;
		return ;
	}
	
	if ( sizeof ( out ) == bW )  
	{
		printf ( "out: \n" ) ;
		for ( i = 0 ; i < bW ; i++ )
			printf(" %02X ", ( UCHAR ) out [ i ] ) ;
		
		printf( "\n" ) ;
	} 
	else 
	{
		printf ( "Failed Req %d wrote %d\n", sizeof ( out ), bW ) ;
		CloseHandle ( h ) ;
		return ;
	}
	
	char in [ 16 ] ;
	DWORD bR ;
	status = ReadFile ( h, in, sizeof ( in ), &bR, NULL ) ;
	if ( ! status ) 
	{
		printf ( "ReadFile failed\n" ) ;
		return ;
	}
	if ( bR == bW ) 
	{
		printf("Buffer was: \n" ) ;

		for ( i = 0 ; i < bR ; i++ )
			printf ( "%02X ", ( UCHAR ) in [ i ] ) ;
		
		printf( "\n" ) ;
	} 
	else 
	{
		printf("Failed Wrote %d Read %d", bW, bR ) ;
		return ;
	}
	status = CloseHandle ( h ) ;
	if ( ! status ) 
	{
		printf( "CloseHandle Failed" ) ;
		return ;
	}
}
